<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('letters', function (Blueprint $table) {
            $table->id();
            $table->string('no_cif');
            $table->string('no_surat');
            $table->string('tgl_surat');
            $table->string('no_req_surat')->nullable();
            $table->string('tgl_req_surat')->nullable();
            $table->string('nama_tujuan',250)->nullable();
            $table->string('alamat', 500)->nullable();
            $table->string('email')->nullable();
            $table->string('tlp')->nullable();
            $table->string('status', 1)->default('1');
            $table->timestamps();
            $table->softDeletes();
            $table->unsignedBigInteger("created_by")->nullable();
            $table->unsignedBigInteger("updated_by")->nullable();
            $table->unsignedBigInteger("deleted_by")->nullable();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('letters');
    }
};