@php
    $route = explode('.', Route::currentRouteName());
@endphp

<!--begin::Modal - New Target-->
<div class="modal fade" id="kt_modal_{{$route[0]}}" tabindex="-1" aria-hidden="true">
	<!--begin::Modal dialog-->
	<div class="modal-dialog modal-dialog-centered mw-650px">
		<!--begin::Modal content-->
		<div class="modal-content rounded">
			<!--begin::Modal header-->
			<div class="modal-header pb-0 border-0 justify-content-end">
				<!--begin::Close-->
				<div class="btn btn-sm btn-icon btn-active-color-primary" data-bs-dismiss="modal">{!! getIcon('cross', 'fs-1') !!}</div>
				<!--end::Close-->
			</div>
			<!--begin::Modal header-->
			<!--begin::Modal body-->
			<div class="modal-body scroll-y px-10 px-lg-15 pt-0 pb-15">
				<!--begin:Form-->
				<form class="form_{{$route[0]}}" method="POST" action="{{ route($route[0].'.store') }}">
                    @csrf
					<!--begin::Heading-->
					<div class="mb-13 text-center">
						<!--begin::Title-->
						<h1 class="mb-3 text-capitalize" id="title_form">{{ str_replace('-',' ',$route[0]) }}</h1>
						<!--end::Title-->
					</div>
					<!--end::Heading-->
					<!--begin::Input group-->
					<div class="d-flex flex-column mb-8 fv-row">
						<!--begin::Label-->
						<label class="d-flex align-items-center fs-6 fw-semibold mb-2">
							<span class="required">Kode</span>
							<span class="ms-1" data-bs-toggle="tooltip" title="Specify a target name for future usage and reference"></span>
						</label>
						<!--end::Label-->
                        <input type="hidden" id="customer_id" name="id" />
						<input type="text" id="customer_kode" minlength="2" maxlength="2" pattern="[0-9]{2,2}" class="form-control form-control-solid" placeholder="Enter Kode customer" name="kode" />
					</div>
					<!--end::Input group-->

                    <!--begin::Input group-->
                    <div class="d-flex flex-column mb-8 fv-row">
                        <!--begin::Label-->
                        <label class="d-flex align-items-center fs-6 fw-semibold mb-2">
                            <span class="required">Name</span>
                            <span class="ms-1" data-bs-toggle="tooltip" title="Specify a target name for future usage and reference"></span>
                        </label>
                        <!--end::Label-->
                        <input type="text" id="customer_name" maxlength="50" class="form-control form-control-solid" placeholder="Enter customer Name" name="name" />
                    </div>
                    <!--end::Input group-->

					<!--begin::Actions-->
					<div class="text-center">
						<button type="reset" data-bs-dismiss="modal" class="btn btn-light me-3">Cancel</button>
						<button type="submit" class="btn btn-primary">Submit</button>
					</div>
					<!--end::Actions-->
				</form>
				<!--end:Form-->
			</div>
			<!--end::Modal body-->
		</div>
		<!--end::Modal content-->
	</div>
	<!--end::Modal dialog-->
</div>
<!--end::Modal - New Target-->
