<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

use Modules\Konfirmasibank\Http\Controllers\KonfirmasiBankController;

$module = file_get_contents(dirname(__FILE__, 2) . '/module.json');
$module = json_decode($module);

Route::group(['middleware' => ['auth', 'verified']], function () {
    Route::post('konfirmasibank/export', [KonfirmasiBankController::class, 'export'])->name('konfirmasibank.export');
    Route::post('konfirmasibank/exportWord', [KonfirmasiBankController::class, 'exportWord'])->name('konfirmasibank.exportWord');
    Route::get('konfirmasibank', 'KonfirmasiBankController@index')->name('konfirmasibank.index');
     Route::get('konfirmasibank/fasilitas', 'KonfirmasiBankController@fasilitas')->name('konfirmasibank.fasilitas');
     Route::get('konfirmasibank/getData',array('as'=>'getData','uses'=>'KonfirmasiBankController@getData'));

   // Route::post('konfirmasibank/postExp', [KonfirmasiBankController::class, 'postExp'])->name('konfirmasibank.postExp');
    Route::post('konfirmasibank/postExp', 'KonfirmasiBankController@postExp')->name('konfirmasibank.postExp');

     Route::get('konfirmasibank/fasilitas',[KonfirmasiBankController::class,'fasilitas'])->name('konfirmasibank.fasilitas');
     Route::get('konfirmasibank/create',[KonfirmasiBankController::class,'create'])->name('konfirmasibank.create');
     Route::post('konfirmasibank/postFasilitas','KonfirmasiBankController@postFasilitas')->name('konfirmasibank.postFasilitas');
     Route::post('konfirmasibank/editFasilitas','KonfirmasiBankController@editFasilitas')->name('konfirmasibank.editFasilitas');
     Route::post('konfirmasibank/update','KonfirmasiBankController@updateFasilitas')->name('konfirmasibank.updateFasilitas');
     Route::post('konfirmasibank/destroy','KonfirmasiBankController@destroyFasilitas')->name('konfirmasibank.destroyFasilitas');
     Route::get('konfirmasibank/signer', [KonfirmasiBankController::class, 'signer'])->name('konfirmasibank.signer');
     Route::post('konfirmasibank/postSigner', [KonfirmasiBankController::class, 'postSigner'])->name('konfirmasibank.postSigner');
     Route::post('konfirmasibank/editSigner','KonfirmasiBankController@editSigner')->name('konfirmasibank.editSigner');
     Route::post('konfirmasibank/updateSigner','KonfirmasiBankController@updateSigner')->name('konfirmasibank.updateSigner');
     Route::post('konfirmasibank/destroySigner','KonfirmasiBankController@destroySigner')->name('konfirmasibank.destroySigner');
});